3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 die "$(eval_gettext "remote (\$remote) does not have a url defined in .git/config")"
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
126 if test -n "$reference"
128 git-clone "$reference" -n "$url" "$path"
130 git-clone -n "$url" "$path"
132 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
136 # Add a new submodule to the working tree, .gitmodules and the index
140 # optional branch is stored in global branch variable
144 # parse $args after "submodule ... add".
149 case "$2" in '') usage ;; esac
160 case "$2" in '') usage ;; esac
161 reference="--reference=$2"
185 if test -z "$path"; then
186 path=$(echo "$repo" |
187 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
190 if test -z "$repo" -o -z "$path"; then
194 # assure repo is absolute or relative to parent
197 # dereference source url relative to parent's url
198 realrepo=$(resolve_relative_url "$repo") || exit
205 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
210 # multiple //; leading ./; /./; /../; trailing /
211 path=$(printf '%s/\n' "$path" |
221 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
222 die "$(eval_gettext "'\$path' already exists in the index")"
224 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
227 eval_gettext "The following path is ignored by one of your .gitignore files:
229 Use -f if you really want to add it." &&
235 # perhaps the path exists and is already a git repo, else clone it
238 if test -d "$path"/.git -o -f "$path"/.git
240 eval_gettext "Adding existing repo at '\$path' to the index"; echo
242 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
247 url=$(resolve_relative_url "$repo") || exit
253 git config submodule."$path".url "$url"
256 module_clone "$path" "$realrepo" "$reference" || exit
260 # ash fails to wordsplit ${branch:+-b "$branch"...}
262 '') git checkout -f -q ;;
263 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
265 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
268 git add $force "$path" ||
269 die "$(eval_gettext "Failed to add submodule '\$path'")"
271 git config -f .gitmodules submodule."$path".path "$path" &&
272 git config -f .gitmodules submodule."$path".url "$repo" &&
273 git add --force .gitmodules ||
274 die "$(eval_gettext "Failed to register submodule '\$path'")"
278 # Execute an arbitrary command sequence in each checked out
281 # $@ = command to execute
285 # parse $args after "submodule ... foreach".
308 while read mode sha1 stage path
310 if test -e "$path"/.git
312 say "$(eval_gettext "Entering '\$prefix\$path'")"
313 name=$(module_name "$path")
315 prefix="$prefix$path/"
319 if test -n "$recursive"
321 cmd_foreach "--recursive" "$@"
324 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
330 # Register submodules in .git/config
332 # $@ = requested paths (default to all)
336 # parse $args after "submodule ... init".
358 while read mode sha1 stage path
360 # Skip already registered paths
361 name=$(module_name "$path") || exit
362 url=$(git config submodule."$name".url)
363 test -z "$url" || continue
365 url=$(git config -f .gitmodules submodule."$name".url)
367 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
369 # Possibly a url relative to parent
372 url=$(resolve_relative_url "$url") || exit
376 git config submodule."$name".url "$url" ||
377 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
379 upd="$(git config -f .gitmodules submodule."$name".update)"
381 git config submodule."$name".update "$upd" ||
382 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
384 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
389 # Update each submodule path to correct revision, using clone and checkout as needed
391 # $@ = requested paths (default to all)
395 # parse $args after "submodule ... update".
416 case "$2" in '') usage ;; esac
417 reference="--reference=$2"
418 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
441 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
447 cmd_init "--" "$@" || return
453 while read mode sha1 stage path
457 echo >&2 "Skipping unmerged submodule $path"
460 name=$(module_name "$path") || exit
461 url=$(git config submodule."$name".url)
462 update_module=$(git config submodule."$name".update)
465 # Only mention uninitialized submodules when its
466 # path have been specified
468 say "$(eval_gettext "Submodule path '\$path' not initialized
469 Maybe you want to use 'update --init'?")"
473 if ! test -d "$path"/.git -o -f "$path"/.git
475 module_clone "$path" "$url" "$reference"|| exit
476 cloned_modules="$cloned_modules;$name"
479 subsha1=$(clear_local_git_env; cd "$path" &&
480 git rev-parse --verify HEAD) ||
481 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
484 if ! test -z "$update"
486 update_module=$update
489 if test "$subsha1" != "$sha1"
492 # If we don't already have a -f flag and the submodule has never been checked out
493 if test -z "$subsha1" -a -z "$force"
498 if test -z "$nofetch"
500 # Run fetch only if $sha1 isn't present or it
501 # is not reachable from a ref.
502 (clear_local_git_env; cd "$path" &&
503 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
504 test -z "$rev") || git-fetch)) ||
505 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
508 # Is this something we just cloned?
509 case ";$cloned_modules;" in
511 # then there is no local change to integrate
516 case "$update_module" in
519 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
520 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
521 must_die_on_failure=yes
525 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
526 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
527 must_die_on_failure=yes
530 command="git checkout $subforce -q"
531 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
532 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
536 if (clear_local_git_env; cd "$path" && $command "$sha1")
539 elif test -n "$must_die_on_failure"
541 die_with_status 2 "$die_msg"
543 err="${err};$die_msg"
548 if test -n "$recursive"
550 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
554 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
557 err="${err};$die_msg"
560 die_with_status $res "$die_msg"
587 git describe "$2" 2>/dev/null ||
588 git describe --tags "$2" 2>/dev/null ||
589 git describe --contains "$2" 2>/dev/null ||
590 git describe --all --always "$2"
593 test -z "$revname" || revname=" ($revname)"
596 # Show commit summary for submodules in index or working tree
598 # If '--cached' is given, show summary between index and given commit,
599 # or between working tree and given commit
601 # $@ = [commit (default 'HEAD'),] requested paths (default all)
608 # parse $args after "submodule ... summary".
622 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
644 test $summary_limit = 0 && return
646 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
650 elif test -z "$1" -o "$1" = "HEAD"
652 # before the first commit: compare with an empty tree
653 head=$(git hash-object -w -t tree --stdin </dev/null)
654 test -z "$1" || shift
662 die "$(gettext -- "--cached cannot be used with --files")"
668 # Get modified modules cared by user
669 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
670 sane_egrep '^:([0-7]* )?160000' |
671 while read mod_src mod_dst sha1_src sha1_dst status name
673 # Always show modules deleted or type-changed (blob<->module)
674 test $status = D -o $status = T && echo "$name" && continue
675 # Also show added or modified modules which are checked out
676 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
681 test -z "$modules" && return
683 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
684 sane_egrep '^:([0-7]* )?160000' |
686 while read mod_src mod_dst sha1_src sha1_dst status name
688 if test -z "$cached" &&
689 test $sha1_dst = 0000000000000000000000000000000000000000
693 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
695 100644 | 100755 | 120000)
696 sha1_dst=$(git hash-object $name)
703 eval_gettext "unexpected mode \$mod_dst" &&
712 test $mod_src = 160000 &&
713 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
716 test $mod_dst = 160000 &&
717 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
721 case "$missing_src,$missing_dst" in
723 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
726 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
729 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
734 if test $mod_src = 160000 -a $mod_dst = 160000
736 range="$sha1_src...$sha1_dst"
737 elif test $mod_src = 160000
743 GIT_DIR="$name/.git" \
744 git rev-list --first-parent $range -- | wc -l
746 total_commits=" ($(($total_commits + 0)))"
750 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
751 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
754 blob="$(gettext "blob")"
755 submodule="$(gettext "submodule")"
756 if test $mod_dst = 160000
758 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
760 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
763 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
767 # Don't give error msg for modification whose dst is not submodule
768 # i.e. deleted or changed to blob
769 test $mod_dst = 160000 && echo "$errmsg"
771 if test $mod_src = 160000 -a $mod_dst = 160000
774 test $summary_limit -gt 0 && limit="-$summary_limit"
775 GIT_DIR="$name/.git" \
776 git log $limit --pretty='format: %m %s' \
777 --first-parent $sha1_src...$sha1_dst
778 elif test $mod_dst = 160000
780 GIT_DIR="$name/.git" \
781 git log --pretty='format: > %s' -1 $sha1_dst
783 GIT_DIR="$name/.git" \
784 git log --pretty='format: < %s' -1 $sha1_src
790 if test -n "$for_status"; then
791 if [ -n "$files" ]; then
792 gettext "# Submodules changed but not updated:"; echo
794 gettext "# Submodule changes to be committed:"; echo
797 sed -e 's|^|# |' -e 's|^# $|#|'
803 # List all submodules, prefixed with:
804 # - submodule not initialized
805 # + different revision checked out
807 # If --cached was specified the revision in the index will be printed
808 # instead of the currently checked out revision.
810 # $@ = requested paths (default to all)
814 # parse $args after "submodule ... status".
839 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
844 while read mode sha1 stage path
846 name=$(module_name "$path") || exit
847 url=$(git config submodule."$name".url)
848 displaypath="$prefix$path"
851 say "U$sha1 $displaypath"
854 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
856 say "-$sha1 $displaypath"
859 set_name_rev "$path" "$sha1"
860 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
862 say " $sha1 $displaypath$revname"
866 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
867 set_name_rev "$path" "$sha1"
869 say "+$sha1 $displaypath$revname"
872 if test -n "$recursive"
875 prefix="$displaypath/"
878 eval cmd_status "$orig_args"
880 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
885 # Sync remote urls for submodules
886 # This makes the value for remote.$remote.url match the value
887 # specified in .gitmodules.
912 while read mode sha1 stage path
914 name=$(module_name "$path")
915 url=$(git config -f .gitmodules --get submodule."$name".url)
917 # Possibly a url relative to parent
920 url=$(resolve_relative_url "$url") || exit
924 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
925 git config submodule."$name".url "$url"
927 if test -e "$path"/.git
932 remote=$(get_default_remote)
933 git config remote."$remote".url "$url"
939 # This loop parses the command line arguments to find the
940 # subcommand name to dispatch. Parsing of the subcommand specific
941 # options are primarily done by the subcommand implementations.
942 # Subcommand specific options such as --branch and --cached are
943 # parsed here as well, for backward compatibility.
945 while test $# != 0 && test -z "$command"
948 add | foreach | init | update | status | summary | sync)
978 # No command word defaults to "status"
979 test -n "$command" || command=status
981 # "-b branch" is accepted only by "add"
982 if test -n "$branch" && test "$command" != add
987 # "--cached" is accepted only by "status" and "summary"
988 if test -n "$cached" && test "$command" != status -a "$command" != summary